datablock TSShapeConstructor(SecurityCameraDts)
{
   baseShape = "./securitycamera.dts";
   sequence0 = "./SC_headside.dsq headside";
   sequence1 = "./SC_root.dsq root";
   sequence2 = "./SC_dead.dsq death1";
   
   sequence3  = "./SC_root.dsq run";
	sequence4  = "./SC_root.dsq walk";
	sequence5  = "./SC_root.dsq back";
	sequence6  = "./SC_root.dsq side";

	sequence7  = "./SC_root.dsq crouch";
	sequence8  = "./SC_root.dsq crouchRun";
	sequence9  = "./SC_root.dsq crouchBack";
	sequence10  = "./SC_root.dsq crouchSide";

	sequence11  = "./SC_root.dsq look";
	sequence12 = "./SC_root.dsq headUp";

	sequence13 = "./SC_root.dsq jump";
	sequence14 = "./SC_root.dsq standjump";
	sequence15 = "./SC_root.dsq fall";
	sequence16 = "./SC_root.dsq land";
	sequence17 = "./SC_root.dsq armAttack";
	sequence18 = "./SC_root.dsq armReadyLeft";
	sequence19 = "./SC_root.dsq armReadyRight";
	sequence20 = "./SC_root.dsq armReadyBoth";
	sequence21 = "./SC_root.dsq spearready";  
	sequence22 = "./SC_root.dsq spearThrow";
	sequence23 = "./SC_root.dsq talk";  

	sequence39 = "./SC_root.dsq death1"; 

	sequence24 = "./SC_root.dsq shiftUp";
	sequence25 = "./SC_root.dsq shiftDown";
	sequence26 = "./SC_root.dsq shiftAway";
	sequence27 = "./SC_root.dsq shiftTo";
	sequence28 = "./SC_root.dsq shiftLeft";
	sequence29 = "./SC_root.dsq shiftRight";
	sequence30 = "./SC_root.dsq rotCW";
	sequence31 = "./SC_root.dsq rotCCW";

	sequence32 = "./SC_root.dsq undo";
	sequence33 = "./SC_root.dsq plant";

	sequence34 = "./SC_root.dsq sit";

	sequence35 = "./SC_root.dsq wrench";

   sequence36 = "./SC_root.dsq activate";
   sequence37 = "./SC_root.dsq activate2";

   sequence38 = "./SC_root.dsq leftrecoil";
};
datablock DebrisData(SecurityCameraDebris)
{
   explodeOnMaxBounce = false;

   elasticity = 0.15;
   friction = 0.5;

   lifetime = 4.0;
   lifetimeVariance = 0.0;

   minSpinSpeed = 40;
   maxSpinSpeed = 600;

   numBounces = 5;
   bounceVariance = 0;

   staticOnMaxBounce = true;
   gravModifier = 1.0;

   useRadiusMass = true;
   baseRadius = 1;

   velocity = 20.0;
   velocityVariance = 12.0;
};             

datablock PlayerData(PlayerCameraArmor:PlayerStandardArmor)
{
   shapeFile = "./SecurityCamera.dts";
   firstPersonOnly=1;
   minLookAngle = -1;
   maxLookAngle = 1;
   lookUpLimit = 0.6;
   lookDownLimit = 0.2;
   maxFreelookAngle = 0.7;

   maxForwardSpeed = 0;
   maxBackwardSpeed = 0;
   maxSideSpeed = 0;
   maxForwardCrouchSpeed = 0;
   maxBackwardCrouchSpeed = 0;
   maxSideCrouchSpeed = 0;
   maxForwardProneSpeed = 0;
   maxBackwardProneSpeed = 0;
   maxSideProneSpeed = 0;
   maxForwardWalkSpeed = 0;
   maxBackwardWalkSpeed = 0;
   maxSideWalkSpeed = 0;
   maxUnderwaterForwardSpeed = 0;
   maxUnderwaterBackwardSpeed = 0;
   maxUnderwaterSideSpeed = 0;
   jumpForce = 0; 
   jumpEnergyDrain = 0;
   minJumpEnergy = 0;
   jumpDelay = 0;
	canJet = 0;
   boundingBox			= "2.5 2.5 2.4";
   crouchBoundingBox	= "2.5 2.5 2.4";
   pickupRadius = 0;
	maxItems   = 0;	//total number of bricks you can carry
	maxWeapons = 0;		//this will be controlled by mini-game code
	maxTools = 0;
	uiName = "";
	rideable = false;
	canRide = true;
	showEnergyBar = false;
	paintable = false;
   numMountPoints = 1;
   mountThread[0] = "root";
   mountNode[0] = 2;
};
datablock ItemData(CameraMountItem)
{
   shapeFile="base/data/shapes/empty.dts";
   uiname="";
   canPickup=0;
   canDrop=0;
   gravityMod=0;
   dynamicType=1;
   observeThroughObject=1;
   emap=1;
   firstPersonOnly=1;
   thirdPersonOnly=0;
   friction=10;
   useEyePoint=0;
};
function CameraMountItem::onPickup(%this)
{
   return;
}
function fxDTSBrick::SpawnCamera(%this)
{
   %i=new Item()
   {
      datablock=CameraMountItem;
      position=vectorAdd(vectorAdd(%this.getPosition(),vectorScale(%this.getForwardVector(),0.5)),"0 0 -0.2");
      scale="1 1 1";
      rotation=%this.rotation;
      canPickup=0;
      cameraBrick=%this;
      spawnBrick=0;
   };
   %this.cameraItem=%i;
   %b=new AIPlayer()
   {
      datablock=PlayerCameraArmor;
      position=%this.getPosition();
      scale="1 1 1";
      cameraBot=1;
      cameraBrick=%this;
      canDismount=0;
   };
   %this.cameraBot=%b;
   %b.playThread(3,"death1");
   %i.mountObject(%b,0);
   if(!isObject(CameraGroup)) new SimGroup(CameraGroup);
   CameraGroup.add(%b);
   CameraGroup.add(%i);
}
datablock fxDTSBrickData(BrickCameraData){
	brickFile="base/data/bricks/bricks/2x2.blb";
	category="Special";
	subCategory="Misc";
	uiName="Camera Brick";                  
	iconName="";
   cameraBrick=1;
};

function BrickCameraData::onPlant(%this,%obj)
{
   Parent::onPlant(%this,%obj);
   if(IsObject(CameraGroup))
      if(CameraGroup.getCount()>40)
         return;
   %obj.spawnCamera();
}

function BrickCameraData::onLoadPlant(%this,%obj)
{
   Parent::onLoadPlant(%this,%obj);
   if(IsObject(CameraGroup))
      if(CameraGroup.getCount()>40)
         return;
    %obj.spawnCamera();
}

function BrickCameraData::onRemove(%this,%obj)
{
   if(%obj.isPlanted() && isObject(%obj.cameraItem))
   {
      %obj.cameraBot.delete();
      %obj.cameraItem.schedule(0,delete);
   }
   Parent::onRemove(%this,%obj);
}

function BrickCameraData::onDeath(%this,%obj)
{
   if(%obj.isPlanted() && isObject(%obj.cameraItem))
   {
      %obj.cameraBot.delete();
      %obj.cameraItem.schedule(0,delete);
   }
   Parent::onDeath(%this,%obj);
}
registerOutputEvent("fxDTSBrick","ControlCamera");
function fxDTSBrick::controlCamera(%this,%client)
{
   if(!%this.getDatablock().cameraBrick)
   {
      %client.centerPrint("\c5This isn't a camera brick",3);
      return;
   }
   if(!isObject(%this.cameraBot))
   {
      %client.centerPrint("\c5There is no camera to control",3);
      return;
   }
   if(isObject(%this.cameraBot.controller))
      if(%this.cameraBot.controller.getControlObject()==%this.cameraBot)
      {
         %client.centerPrint("\c5That camera is being used",3);
         return;
      }
   if(!isObject(%player=%client.player))
   {
      %client.centerPrint("\c5You don't have a player",3);
      return;
   }
   %client.setControlObject(%this.cameraBot);
   %this.cameraBot.controller=%client;
   %this.cameraBot.playThread(3,"root");
   %client.centerPrint("\c5Press your \c3Light Key\c5 to leave the camera",3);
}
if(isPackage(SecurityCamera))
   deactivatepackage(SecurityCamera);
package SecurityCamera
{
   function servercmdLight(%c)
   {
      if(isObject(%o=%c.getControlObject()))
      {
         if(%o.cameraBot && %o.getDatablock() == nameToID("PlayerCameraArmor"))
         {
            %c.setControlObject((isObject(%c.player)?%c.player:%c.camera));
            %o.cameraBrick.controller=0;
            %o.playThread(3,"death1");
            return;
         }
      }
      Parent::servercmdLight(%c);
   }
   function serverCmdAlarm(%c)
   {
      if(!isObject(AlarmProjectile))
         return;
      if(isObject(%o=%c.getControlObject()))
      {
         if(%o.cameraBot && %o.getDatablock() == nameToID("PlayerCameraArmor"))
         {
            %o.emote(AlarmProjectile);
            return;
         }
      }
      Parent::servercmdAlarm(%c);
   }
};
activatepackage(SecurityCamera);